//#############################################################################   
//
//	adc-demo.c
//
//#############################################################################

#include <stdio.h>
#include <stdlib.h>
#include <usb.h>
#include <time.h>
#include <errno.h>
#include <string.h>
#include <curses.h>

#include "usb4all.h"

// Achtung benötige Paket libncurses5-dev

//#############################################################################   
//
//       Hauptprogram
//
//#############################################################################
  
int main(void)

{
  int cmd_cnt;
  int buf_cnt;
  unsigned char cmd[USB_BLOCKSIZE];
  unsigned char buf[USB_BLOCKSIZE];
  struct usb4all_t usb4all;
  
  int kanal;
  int messung;
  
  usb4all_initialize(&usb4all);

  if (usb4all_connect(&usb4all)) {
     perror("Connect Error");
     usb4all_finalize(&usb4all);
     return 1;
  }

  printf("USB4ALL: %s\n",usb4all.usb_name);
  
  cmd_cnt = 4;
  cmd[0]=0x51;	// ADC
  cmd[1]=0x01;	// Init
  cmd[2]=4;	// AN0..AN3
  cmd[3]=0;	// Ref 0V und 5V
  buf_cnt = usb4all_data_io(&usb4all,cmd,cmd_cnt,buf,sizeof(buf));
  if (buf_cnt<0) {
     perror("Error");
     usb4all_finalize(&usb4all);
     return 1;
  }

  kanal = 0;
  messung = 0;

  initscr();
  cbreak();
  timeout(0);
  nonl();
  keypad(stdscr, TRUE);
  noecho();

  mvprintw(1,1,"ADC-DEMO (Abbruch mit beliebiger Taste)");
  
  mvprintw(3,1,"Messung:");

  mvprintw(5+0,1,"Kanal0:");
  mvprintw(5+1,1,"Kanal1:");
  mvprintw(5+2,1,"Kanal2:");
  mvprintw(5+3,1,"Kanal3:");

  do {

    cmd_cnt = 3;
    cmd[0]=0x51;	// ADC
    cmd[1]=2;		// set AN
    cmd[2]=kanal;	// ANx Eingang
    buf_cnt = usb4all_data_io(&usb4all,cmd,cmd_cnt,buf,sizeof(buf));
    if (buf_cnt<0) break;
    
    cmd_cnt = 2;
    cmd[0]=0x51;	// ADC
    cmd[1]=3;		// Messen  
    buf_cnt = usb4all_data_io(&usb4all,cmd,cmd_cnt,buf,sizeof(buf));
    if (buf_cnt<0) break;

    mvprintw(3,10," %08d ",messung);
    mvprintw(5+kanal,10,"%04d",buf[2]+(buf[3]<<8));
    
    kanal++; if (kanal>3) { kanal=0; messung++; }
  }
  while (getch() == -1);

  endwin();
  
  if (buf_cnt<0) perror("Error");
 
  usb4all_finalize(&usb4all);

}

//#############################################################################
