//#############################################################################   
//
//	port-demo.c
//
//#############################################################################

#include <stdio.h>
#include <stdlib.h>
#include <usb.h>
#include <time.h>
#include <errno.h>
#include <string.h>
#include <curses.h>

#include "usb4all.h"

// Achtung benötige Paket libncurses5-dev

//#############################################################################   
//
//       Hauptprogram
//
//#############################################################################
  
int main(void)

{
  int cmd_cnt;
  int buf_cnt;
  unsigned char cmd[USB_BLOCKSIZE];
  unsigned char buf[USB_BLOCKSIZE];
  struct usb4all_t usb4all;
  
  int messung;
  
  usb4all_initialize(&usb4all);

  if (usb4all_connect(&usb4all)) {
     perror("Connect Error");
     usb4all_finalize(&usb4all);
     return 1;
  }

  printf("USB4ALL: %s\n",usb4all.usb_name);
  
  cmd_cnt = 6;
  cmd[0]=0x50;	// PORT
  cmd[1]=1;	// Init
  cmd[2]=0xff;	// PortA Eingang
  cmd[3]=0xff;	// PortB Eingang
  cmd[4]=0xff;	// PortC Eingang
  cmd[5]=0xFF;	// PortB Pullup ein
  buf_cnt = usb4all_data_io(&usb4all,cmd,cmd_cnt,buf,sizeof(buf));
  if (buf_cnt<0) {
     perror("Error");
     usb4all_finalize(&usb4all);
     return 1;
  }

  messung = 0;

  initscr();
  cbreak();
  timeout(0);
  nonl();
  keypad(stdscr, TRUE);
  noecho();

  mvprintw(1,1,"PORT-DEMO (Abbruch mit beliebiger Taste)");
  
  mvprintw(3,1,"Messung:");

  mvprintw(5+0,1,"Port A:");
  mvprintw(5+1,1,"Port B:");
  mvprintw(5+2,1,"Port C:");

  do {
    
    cmd_cnt = 2;
    cmd[0]=0x50;	// PORT
    cmd[1]=3;		// Alle lesen
    buf_cnt = usb4all_data_io(&usb4all,cmd,cmd_cnt,buf,sizeof(buf));
    if (buf_cnt<0) break;

    mvprintw(3,10," %08d ",messung);
    mvprintw(5+0,10,"%02X",buf[2]);
    mvprintw(5+1,10,"%02X",buf[3]);
    mvprintw(5+2,10,"%02X",buf[4]);
    
    messung++;
  }
  while (getch() == -1);

  endwin();
  
  if (buf_cnt<0) perror("Error");
 
  usb4all_finalize(&usb4all);

}

//#############################################################################
